leetcode 629. K Inverse Pairs Array K个逆序对 + 动态规划DP

来源:互联网 发布:php默认登录页面 编辑:程序博客网 时间:2024/06/05 02:55

Given two integers n and k, find how many different arrays consist of numbers from 1 to n such that there are exactly k inverse pairs.

We define an inverse pair as following: For ith and jth element in the array, if i < j and a[i] > a[j] then it’s an inverse pair; Otherwise, it’s not.

Since the answer may be very large, the answer should be modulo 109 + 7.

Example 1:
Input: n = 3, k = 0
Output: 1
Explanation:
Only the array [1,2,3] which consists of numbers from 1 to 3 has exactly 0 inverse pair.
Example 2:
Input: n = 3, k = 1
Output: 2
Explanation:
The array [1,3,2] and [2,1,3] have exactly 1 inverse pair.
Note:
The integer n is in the range [1, 1000] and k is in the range [0, 1000].

本题题意很简单,最直接的方法是就是使用DFS求全排列,然后作判断,但是想都不用想肯定会超时,所以肯定是使用DP来做的嘛,

参考链接:[LeetCode] K Inverse Pairs Array K个翻转对数组

代码如下:

#include <iostream>#include <vector>#include <map>#include <set>#include <queue>#include <stack>#include <string>#include <climits>#include <algorithm>#include <sstream>#include <functional>#include <bitset>#include <numeric>#include <cmath>#include <regex>using namespace std;class Solution {public:    int kInversePairs(int n, int k)     {           int M = 1000000007;        vector<vector<int>> dp(n + 1, vector<int>(k + 1, 0));        dp[0][0] = 1;        for (int i = 1; i <= n; i++)        {            dp[i][0] = 1;            for (int j = 1; j <= k; j++)            {                dp[i][j] = (dp[i - 1][j] + dp[i][j - 1]) % M;                if (j >= i) //注意这里是j-i                    dp[i][j] = (dp[i][j] - dp[i - 1][j - i] + M) % M;            }        }        return dp[n][k];    }};
原创粉丝点击